/*
 * uuid.h -- private header file for uuids
 * 
 * Copyright (C) 1996, 1997 Theodore Ts'o.
 *
 * %Begin-Header%
 * This file may be redistributed under the terms of the GNU Public
 * License.
 * %End-Header%
 */

#ifdef WIN32
#include <rpc.h>
#include <rpcdce.h>
/* Need to redefine uuid_t from rpcdce */
#undef uuid_t
/* From glib and types */
typedef unsigned long guint32;
typedef unsigned short guint16;
typedef unsigned char guint8;
typedef unsigned char guchar;
#else /* !WIN32 */

#include <sys/types.h>

/* OS X doesn't have glib by default, but otherwise works fine */
#if defined(__APPLE_CC__)
typedef unsigned long guint32;
typedef unsigned short guint16;
typedef unsigned char guint8;
typedef unsigned char guchar;
#else
#include <glib.h>
#endif /* __APPLE_CC__ */

#endif /* WIN32 */

#include "uuid.h"

/*
 * Offset between 15-Oct-1582 and 1-Jan-70
 */
#define TIME_OFFSET_HIGH 0x01B21DD2
#define TIME_OFFSET_LOW  0x13814000

struct uuid {
	guint32	time_low;
	guint16	time_mid;
        guint16	time_hi_and_version;
	guint16	clock_seq;
        guint8	node[6];
};


/*
 * prototypes
 */
void uuid_pack(struct uuid *uu, uuid_t ptr);
void uuid_unpack(uuid_t in, struct uuid *uu);




